%if 0%{?rhel} <= 5
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%{!?python_version: %global python_version %(%{__python} -c "import sys; print('%s.%s'%sys.version_info[:2])")}
%{!?python_version_nodot: %global python_version_nodot %(%{__python} -c "import sys; print('%s%s'%sys.version_info[:2])")}

## add filter setup
%{?filter_setup:
%filter_provides_in %{python_sitearch}.*\.so$
%filter_setup
}


Name:						lcg-util
Version:					1.12.0
Release:					2%{?dist}
Summary:					Command line tools for wlcg storage system 
Group:						Applications/Internet
License:					ASL 2.0
URL:						https://svnweb.cern.ch/trac/lcgutil
# svn export http://svn.cern.ch/guest/lcgutil/lcg-util/trunk lcgutil
Source0:					http://grid-deployment.web.cern.ch/grid-deployment/dms/lcgutil/tar/%{name}/%{name}-%{version}.tar.gz 
BuildRoot:					%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
# exclude ppc architecture, impossible to compile gfal correctly with the epel 5 gcc version
ExcludeArch:				ppc 

BuildRequires:				automake
BuildRequires:				CGSI-gSOAP-devel
BuildRequires:				gfal-devel
BuildRequires:				globus-ftp-client-devel
BuildRequires:				gridftp-ifce-devel
BuildRequires:				libtool
%if 0%{?el5}
BuildRequires:				e2fsprogs-devel
%else
BuildRequires:				libuuid-devel	
%endif
BuildRequires:				python-devel
BuildRequires:				srm-ifce-devel
BuildRequires:				swig
BuildRequires:				voms-devel


%description
The LCG Utilities package is the main end user command line tool \
for data management provided by LCG \
(applications will generally use the Grid File Access Library).

%package libs
Summary:					Shared library related to %{name} tools
Group:						Applications/Internet

%description libs
Shared libraries component for %{name}

%package devel
Summary:					Headers and development files for %{name} tools
Group:						Applications/Internet
Requires:					%{name}-libs%{?_isa} = %{version}

%description devel
This package contains development files for %{name} 

%package python
Summary:					Python bindings for %{name}
Group:						Applications/Internet
Provides:					%{name}-py%{python_version_nodot} = %{version}
Requires:					%{name}-libs%{?_isa} = %{version}

%description python
python bindings for %{name}

%prep
%setup -q

%build
mkdir -p src/autogen build; 
aclocal -I m4-EPEL/; 
libtoolize --force; 
autoheader; 
automake --foreign --add-missing --copy; 
autoconf
cd build; 
../configure \
--enable-debug \
--enable-wall \
--prefix=%{_prefix}  \
--libdir=%{_libdir} \
--with-version=%{version} \
--with-release=%{release} \
--with-gfal-location=/ \
--with-voms-location=/ \
--with-emi \
--with-pythonrelease=%{python_version} \
--disable-static \
--disable-tests \
--enable-epel
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make -C build %{?_smp_mflags} DESTDIR=%{buildroot} install;
#remove libtool files
rm -f %{buildroot}/%{_libdir}/liblcg_util.*a
rm -f %{buildroot}/%{python_sitearch}/_lcg_util.*a

%clean
rm -rf %{buildroot}

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files libs
%defattr (-,root,root)
%{_libdir}/liblcg_util.so.*
%{_docdir}/%{name}-%{version}/README_LIBS


%files devel
%defattr (-,root,root)
%{_includedir}/lcg_util.h
%{_docdir}/%{name}-%{version}/RELEASE-NOTES
%{_mandir}/man3/*
%{_libdir}/liblcg_util.so

%files python
%defattr (-,root,root)
%{python_sitearch}/lcg_util.py*
%{python_sitearch}/_lcg_util.so
%{python_sitearch}/_lcg_util.so.*
%{_docdir}/%{name}-%{version}/README_PYTHON


%files
%defattr (-,root,root)
%{_docdir}/%{name}-%{version}/VERSION
%{_docdir}/%{name}-%{version}/LICENSE
%{_docdir}/%{name}-%{version}/README
%{_mandir}/man1/*
%{_bindir}/lcg-aa
%{_bindir}/lcg-bringonline
%{_bindir}/lcg-cp
%{_bindir}/lcg-cr
%{_bindir}/lcg-del
%{_bindir}/lcg-get-checksum
%{_bindir}/lcg-getturls
%{_bindir}/lcg-gt
%{_bindir}/lcg-la
%{_bindir}/lcg-lg
%{_bindir}/lcg-lr
%{_bindir}/lcg-ls
%{_bindir}/lcg-ra
%{_bindir}/lcg-rep
%{_bindir}/lcg-replica-manager
%{_bindir}/lcg-rf
%{_bindir}/lcg-sd
%{_bindir}/lcg-stmd
%{_bindir}/lcg-uf



%changelog
* Fri Mar 02 2012 <adevress at cern.ch> - 1.12.0-2
 - fix the compilation for the ppc architecture
 
* Tue Dec 13 2011 <adevress at cern.ch> - 1.12.0-1
 - Initial build 
