.\" @(#)$RCSfile: lcg-stmd.man,v $ $Revision: 1.5 $ $Date: 2009/11/19 13:58:41 $ CERN Remi Mollon
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH LCG-LR 1 "$Date: 2009/11/19 13:58:41 $" LCG_UTIL "User Commands"

.SH NAME
lcg-stmd \- get space tokens associated to a space token description, and their metadata

.SH SYNOPSIS
.B lcg-stmd
[
.B -h,--help
] [
.B -b,--nobdii
] [
.B -v,--verbose
] [
.B  --connect-timeout "timeout"
] [
.B  --sendreceive-timeout "timeout"
] [
.B  --bdii-timeout "timeout"
] [
.B  --srm-timeout "timeout"
] [
.B --version
]
.BI -s,--spacetokendesc " spacetokendesc"
.BI -e,--endpoint " endpoint"

.SH DESCRIPTION
.B lcg-stmd
get space tokens associated to a space token description, and their metadata. If you specify a given command line option
multiple times, the command takes into account only the very last one so that in a script, you can
override a particular option in a pre-set option set (like gcc does).
.TP
.B --connect-timeout
Sets the connect timeout, used when connecting to a remote host. The connection will be aborted
if the remote host doesn't reply after
.I value
seconds. Default: 60 seconds.
.TP
.B --sendreceive-timeout
Sets the send/receive data timeout, used when transferring data to/from a remote host. The connection will be aborted
if no data is transfered after
.I value
seconds. Default: 0 (blocking).
.TP
.B --bdii-timeout
Sets the BDII timeout, used when searching information into BDII. The connection will be aborted
if the search is longer than
.I value
seconds. Default: 60 seconds.
.TP
.B --srm-timeout
Sets the SRM timeout, used when doing an asynchronous SRM request. The request will be aborted
if it is still queued after
.I value
seconds. Default: 3600 seconds (1 hour).
.TP
.B -i,--insecure
Insecure mode. This argument is currently ignored.
.TP
.B -b,--nobdii
If this flag is present, it means that you don't want to make BDII calls to get SE type.
So, you must provide the full (SRMv2) endpoint.
.TP
.I timeout
specifies the value of timeout (default 0).
.TP
.I spacetokendesc
specify the space token description whom you want to get metadata from.
.TP
.I endpoint
the endpoint of the SE where the
.I spacetokendesc
is defined. Note that as only SRMv2 supports space tokens the endpoint must be SRMv2-compliant.
.TP
.B -v,--verbose
Verbose mode. You can specify it twice for extra verbose mode.

.SH NOTE
Only SRMv2 supports space tokens, so this function is compatible with SRMv2 endpoints only.
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I --bdii
option is used.

.SH EXAMPLE
.nf
.ft CW
	lcg-stmd -be httpg://lxdpm103.cern.ch:8446/srm/managerv2 -s remispace

	+ Space Token: 3a5c5511-0638-45cc-bbb8-2f63f28af067
	  - Owner: root
	  - Total Size: 2097152
	  - Guaranteed Size: 2097152
	  - Unused Size: 2097152
	  - Assigned Lifetime: 499042
	  - Left Lifetime: -1
	  - Retention Policy: CUSTODIAL
	  - Access Latency: ONLINE

.ft
.fi

.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH SEE ALSO
.BR lcg-aa (1),
.BR lcg-cp (1),
.BR lcg-cr (1),
.BR lcg-del (1),
.BR lcg-getturls (1),
.BR lcg-gt (1),
.BR lcg-la (1),
.BR lcg-lg (1),
.BR lcg-ls (1),
.BR lcg-ra (1),
.BR lcg-rep (1),
.BR lcg-rf (1),
.BR lcg-sd (1),
.BR lcg-stmd (1),
.BR lcg-uf (1)
