.\" @(#)$RCSfile: lcg-uf.man,v $ $Revision: 1.13 $ $Date: 2009/11/19 13:58:41 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH LCG-UF 1 "$Date: 2009/11/19 13:58:41 $" LCG_UTIL "User Commands"

.SH NAME
lcg-uf \- unregister in the LRC a file residing on an SE

.SH SYNOPSIS
.B lcg-uf
[
.BI --config " config_file"
] [
.B -h,--help
] [
.B -v,--verbose
] [
.B  --connect-timeout "timeout"
] [
.B  --sendreceive-timeout "timeout"
] [
.B  --bdii-timeout "timeout"
] [
.B -f
] [
.BI --vo " virtual_organization"
] [
.B --version
]
.I guid
.I surl

.SH DESCRIPTION
.B lcg-uf
unregisters in the LRC or the LFC a file residing on an SE.
If it was the last or only valid replica, the entries corresponding to this
GUID are also removed from the RMC or the LFC. If you specify a given command line option
multiple times, the command takes into account only the very last one so that in a script, you can
override a particular option in a pre-set option set (like gcc does).
.TP
.I surl
specifies the site URL of the file to be unregistered. The scheme can be
.B sfn:
for a classical SE or
.BR srm: .
.TP
.I guid
specifies the Grid Unique IDentifier.
.TP
.B --connect-timeout
Sets the connect timeout, used when connecting to a remote host. The connection will be aborted
if the remote host doesn't reply after
.I value
seconds. Default: 60 seconds.
.TP
.B --sendreceive-timeout
Sets the send/receive data timeout, used when transferring data to/from a remote host. The connection will be aborted
if no data is transfered after
.I value
seconds. Default: 0 (blocking).
.TP
.B --bdii-timeout
Sets the BDII timeout, used when searching information into BDII. The connection will be aborted
if the search is longer than
.I value
seconds. Default: 60 seconds.
.TP
.I vo
specifies the Virtual Organization the user belongs to. If it is not specified,
the environment variable LCG_GFAL_VO will be used.
.TP
.I conf_file
This argument is currently ignored.
.TP
.B -f
Force mode. Ignore nonexistent-file errors.
.TP
.B -v,--verbose
Verbose mode. You can specify it twice for extra verbose mode.

.SH NOTE
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I --nobdii
option is used.
To use the RLS as catalog instead of the LFC, the environment variable
LCG_CATALOG_TYPE must explicitely be set to "edg". By default, it is set to "lfc".

.SH EXAMPLE
.nf
.ft CW
	lcg-uf --vo dteam guid:4fd28653-b076-4336-811e-7d5a553e0d7f \\
		srm://lxshare0282.cern.ch//pnfs/cern.ch/data/dteam/testjpb16
.ft
.fi

.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH SEE ALSO
.BR lcg-aa (1),
.BR lcg-cp (1),
.BR lcg-cr (1),
.BR lcg-del (1)
.BR lcg-getturls (1),
.BR lcg-gt (1),
.BR lcg-la (1),
.BR lcg-lg (1),
.BR lcg-lr (1),
.BR lcg-ls (1),
.BR lcg-ra (1),
.BR lcg-rep (1),
.BR lcg-rf (1),
.BR lcg-sd (1),
.BR lcg-stmd (1),
.BR lcg-uf (1),
