.\" @(#)$RCSfile: lcg_aa.man,v $ $Revision: 1.10 $ $Date: 2008/05/07 12:40:27 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH LCG_AA 3 "$Date: 2008/05/07 12:40:27 $" LCG_UTIL "Library Functions"

.SH NAME
lcg_aa \- add an alias in the RMC or the LFC for a given GUID

.SH SYNOPSIS
\fB#include "lcg_util.h"\fR
.sp
.BI "int lcg_aa (char *" lfn ,
.BI "char *" guid ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure );
.sp
.BI "int lcg_aax (char *" lfn ,
.BI "char *" guid ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_aa2 (char *" lfn ,
.BI "char *" guid ,
.BI "int " nobdii ,
.BI "char *" vo ,
.BI "char *" errbuf ,
.BI "int " errbufsz );

.SH "DESCRIPTION"
.B lcg_aa
adds an alias in the RMC or the LFC for a given GUID.
.TP
.I lfn
specifies the new alias.
.TP 
.I guid
specifies the Grid Unique IDentifier.
.TP
.I nobdii
If set to a non-zero value, it means that you don't want to make BDII calls to get LFC endpoint.
So, you have to define the environment variable 'LFC_HOST'.
.TP 
.I vo
specifies the Virtual Organization the user belongs to. If it is not specified,
the environment variable LCG_GFAL_VO will be used.
.TP 
.I conf_file
This argument is currently ignored.
.TP 
.I insecure
This argument is actually ignored.
.TP 
.I errbuf
specifies a buffer of size
.I errbufsz
to receive detailed error messages. If this pointer is NULL, the message goes
to stderr. The pointer should not be NULL if the application is a daemon or is
multi\-threaded.

.SH "NOTE"
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I nobdii
is set to a non-zero value.
To use the RLS as catalog instead of the LFC, the environment variable
LCG_CATALOG_TYPE must explicitely be set to "edg". By default, it is set to "lfc".

.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B errno
is set appropriately.

.SH "ERRORS"
.TP 1.3i
.B EEXIST
The alias exists already.
.TP 
.B EFAULT
.I lfn ,
.I guid
or
.I vo
is an invalid pointer.
.TP 
.B ECOMM
Communication error.
.TP
.B ENAMETOOLONG
.I vo
is too long.

.SH "FILES"
.B /opt/lcg/include/lcg_util.h
.TP 
.B /opt/lcg/lib/liblcg_util.so

.SH "SEE ALSO"
.BR lcg_aa (3),
.BR lcg_cp (3),
.BR lcg_cr (3),
.BR lcg_del (3),
.BR lcg_gt (3),
.BR lcg_la (3),
.BR lcg_lg (3),
.BR lcg_lr (3),
.BR lcg_ra (3),
.BR lcg_rep (3),
.BR lcg_rf (3),
.BR lcg_sd (3),
.BR lcg_stmd (3),
.BR lcg_uf (3)
