.\" @(#)$RCSfile: lcg_set_transfer_callback.man,v $ $Revision: 1.2 $ $Date: 2009/04/16 15:51:30 $ CERN Remi Mollon
.\" Copyright (C) 2009 by CERN
.\" All rights reserved
.\"
.TH LCG_SET_TRANSFER_CALLBACK 3 "$Date: 2009/04/16 15:51:30 $" LCG_UTIL "Library Functions"

.SH NAME
lcg_set_transfer_callback \- Get/Set the pointer of the transfer file callback

.SH SYNOPSIS
\fB#include "lcg_util.h"\fR
.sp
.BI "void lcg_set_transfer_callback (copyfile_callback_t *" cb );
.sp
.B copyfile_callback_t lcg_get_transfer_callback ();

.SH "DESCRIPTION"
.B lcg_set_transfer_callback
sets the pointer of the transfer file callback 
.TP
.I cb
specifies the pointer to the desired function.

    typedef struct {
    	GFAL_LONG64 transferred_bytes;
    	float instant_throughput;
    	float avg_throughput;
    } perf_t;
    
    typedef void (* copyfile_callback_t) (
    	perf_t                  s_perf,
    	struct  timespec        ts,
    	int                     *timeoutflg
   	);

.SH "EXAMPLE"
Here is the function which is used in verbose mode:

    void copy_print_callback(perf_t perf, struct timespec ts, int *timeoutflg) {
        fprintf(stderr,"\\r %12lld bytes", (GFAL_LONG64)perf.transferred_bytes);
        fprintf(stderr," %9.2lf KB/sec avg", (double)perf.avg_throughput/1024);
        fprintf(stderr," %9.2lf KB/sec inst", (double)perf.instant_throughput/1024);
    }


.SH "FILES"
.B /opt/lcg/include/lcg_util.h
.TP 
.B /opt/lcg/lib/liblcg_util.so

.SH "SEE ALSO"
.BR lcg_cp (3),
.BR lcg_cr (3),
.BR lcg_del (3),
.BR lcg_gt (3),
.BR lcg_la (3),
.BR lcg_lg (3),
.BR lcg_lr (3),
.BR lcg_ra (3),
.BR lcg_rep (3),
.BR lcg_rf (3),
.BR lcg_sd (3),
.BR lcg_stmd (3),
.BR lcg_uf (3)
