%module lcg_util

%{
#include "lcg_util.h"
%}

%include "lcg-typemaps.python.i"

enum se_type {TYPE_NONE = 0, TYPE_SRM, TYPE_SRMv2, TYPE_SE};
enum gfal_cksm_type {GFAL_CKSM_NONE = 0, GFAL_CKSM_CRC32,
    GFAL_CKSM_ADLER32, GFAL_CKSM_MD5, GFAL_CKSM_SHA1};



extern const char *lcg_util_version ();

extern int lcg_gt (char *surl, char *protocol, char **OUTPUT, int *OUTPUT, int *OUTPUT, char **OUTPUT);
extern int lcg_gt2 (char *surl, char **protocols, char **OUTPUT, int *OUTPUT, int *OUTPUT,
		    char **OUTPUT, char *errbuf, int errbufsz, int timeout, char *spacetokendesc);
extern int lcg_gt3 (char *surl, enum se_type defaulttype, enum se_type setype, int nobdii, char **protocols, char **OUTPUT,
		    int *OUTPUT, int *OUTPUT, char **OUTPUT, char *errbuf, int errbufsz, int timeout, char *spacetokendesc);

extern int lcg_la (char *file, char *vo, char *conf_file, int insecure, char ***OUTPUT);
extern int lcg_lax (char *file, char *vo, char *conf_file, int insecure, char ***OUTPUT,
		    char *errbuf, int errbufsz);
extern int lcg_la2 (char *file, int nobdii, char *vo, char ***OUTPUT, char *errbuf, int errbufsz);

extern int lcg_lr (char *file, char *vo, char *conf_file, int insecure, char ***OUTPUT);
extern int lcg_lrx (char *file, char *vo, char *conf_file, int insecure, char ***OUTPUT,
		    char *errbuf, int errbufsz);
extern int lcg_lr2 (char *file, int nobdii, char *vo, char ***OUTPUT, char *errbuf, int errbufsz);
extern int lcg_lr3 (char *file, int nobdii, char *vo, char ***OUTPUT, int verbose, char *errbuf, int errbufsz);

extern int lcg_cp (char *, char *, char *, int, char *, int, int);
extern int lcg_cp2 (char *src_file, char *dest_file, char *vo, int nbstreams, char *conf_file,
		    int insecure, int verbose, int timeout, char *src_spacetokendesc,
		    char *dest_spacetokendesc, char *errbuf, int errbufsz);
extern int lcg_cp3 (char *src_file, char *dest_file, enum se_type defaulttype, enum se_type srctype, enum se_type dsttype, int nobdii,
		    char *vo, int nbstreams, char *conf_file, int insecure, int verbose, int timeout, char *src_spacetokendesc,
		    char *dest_spacetokendesc, char *errbuf, int errbufsz);
extern int lcg_cp4 (char *src_file, char *dest_file, enum se_type defaulttype, enum se_type srctype, enum se_type dsttype, int nobdii,
		    char *vo, int nbstreams, char *conf_file, int insecure, int verbose, int timeout, char *src_spacetokendesc,
		    char *dest_spacetokendesc, enum gfal_cksm_type cksmtype, char *errbuf, int errbufsz);

extern int lcg_lg (char *file, char *vo, char *conf_file, int insecure, char *GUIDOUT);
extern int lcg_lgx (char *file, char *vo, char *conf_file, int insecure, char *GUIDOUT,
		    char *errbuf, int errbufsz);
extern int lcg_lg2 (char *file, int nobdii, char *vo, char *GUIDOUT, char *errbuf, int errbufsz);

extern int lcg_uf (char *surl, char *guid, char *vo, char *conf_file, int insecure);
extern int lcg_ufx (char *surl, char *guid, char *vo, char *conf_file, int insecure,
		    char *errbuf, int errbufsz);
extern int lcg_uf3 (char *surl, char *guid, char *vo, char *conf_file, int insecure,
		    int verbose, char *errbuf, int errbufsz);
extern int lcg_uf4 (char *surl, char *guid, int nobdii, char *vo, int verbose, char *errbuf, int errbufsz);

extern int lcg_del (char *, int, char *, char *, char *, int, int);
extern int lcg_delxt (char *file, int aflag, char *se, char *vo, char *conf_file,
		      int insecure, int verbose, int timeout, char *errbuf, int errbufsz);
extern int lcg_del3 (char *file, enum se_type defaulttype, enum se_type setype, int nobdii,
		    int aflag, char *se, char *vo, char *conf_file, int insecure, int verbose,
		    int timeout, char *errbuf, int errbufsz);
extern int lcg_del4 (char *file, enum se_type defaulttype, enum se_type setype, int nobdii,
		    int nolfc, int aflag, char *se, char *vo, char *conf_file, int insecure, int verbose,
		    int timeout, char *errbuf, int errbufsz);
extern int lcg_del5 (int LEN, char **LIST, enum se_type defaulttype, enum se_type setype, int nobdii,
		    int nolfc, int aflag, char *se, char *vo, char *conf_file, int insecure,
		    int verbose, int timeout, lcg_filestatus **OUTPUT, char *errbuf, int errbufsz);
extern int lcg_del6 (int LEN, char **LIST, enum se_type defaulttype, enum se_type setype, int nobdii,
		    int nolfc, int aflag, char *se, char *vo, char *conf_file, int insecure, int verbose,
		    int bool_force, int timeout, lcg_filestatus **OUTPUT, char *errbuf, int errbufsz);
extern int lcg_del7 (int LEN, char **LIST, enum se_type defaulttype, enum se_type setype, int nobdii,
		    int nolfc, int aflag, char *se, char *vo, char *conf_file, int insecure, int verbose,
		    int bool_force, int bool_rmdir, int timeout, lcg_filestatus **OUTPUT, char *errbuf, int errbufsz);

extern int lcg_aa (char *lfn, char *guid, char *vo, char *conf_file, int insecure);
extern int lcg_aax (char *lfn, char *guid, char *vo, char *conf_file, int insecure,
		    char *errbuf, int errbufsz);
extern int lcg_aa2 (char *lfn, char *guid, int nobdii, char *vo, char *errbuf, int errbufsz);

extern int lcg_ra (char *lfn, char *guid, char *vo, char *conf_file, int insecure);
extern int lcg_rax (char *lfn, char *guid, char *vo, char *conf_file, int insecure,
		    char *errbuf, int errbufsz);
extern int lcg_ra2 (char *lfn, char *guid, int nobdii, char *vo, char *errbuf, int errbufsz);

extern int lcg_rep (char *src_file, char *dest_file, char *vo, char *relative_path,
		    int nbstreams, char *conf_file, int insecure, int verbose);
extern int lcg_rep2 (char *src_file, char *dest_file, char *vo, char *relative_path,
		     int nbstreams, char *conf_file, int insecure, int verbose, int timeout,
		     char *source_spacetokendesc, char *dest_spacetokendesc, char *errbuf, int errbufsz);
extern int lcg_rep3 (char *src_file, char *dest_file, enum se_type defaulttype, enum se_type srctype, enum se_type dsttype, int nobdii,
		    char *vo, char *relative_path, int nbstreams, char *conf_file, int insecure, int verbose, int timeout,
		    char *src_spacetokendesc, char *dest_spacetokendesc, char **OUTPUT, char *errbuf, int errbufsz);
extern int lcg_rep4 (char *src_file, char *dest_file, enum se_type defaulttype, enum se_type srctype, enum se_type dsttype, int nobdii,
		    char *vo, char *relative_path, int nbstreams, char *conf_file, int insecure, int verbose, int timeout,
		    char *src_spacetokendesc, char *dest_spacetokendesc, char **OUTPUT, enum gfal_cksm_type cksmtype, char *errbuf, int errbufsz);

extern int lcg_sd (char *surl, int reqid, int fileid, char *token, int oflag);
extern int lcg_sdxt (char *surl, int reqid, int fileid, char *token, int oflag,
		    char *errbuf, int errbufsz, int timeout);
extern int lcg_sd3 (char *surl, int nobdii, int reqid, int fileid,
		    char *reqtoken, char *errbuf, int errbufsz, int timeout);

extern int lcg_cr (char *src_file, char *dest_file, char *guid, char *lfn, char *vo,
		   char *relative_path, int nbstreams, char *conf_file, int insecure,
		   int verbose, char *GUIDOUT);
extern int lcg_cr2 (char *src_file, char *dest_file, char *guid, char *lfn, char *vo,
		    char *relative_path, int nbstreams, char *conf_file, int insecure,
		    int verbose, int timeout, char *spacetokendesc, char *GUIDOUT,
		    char *errbuf, int errbufsz);
extern int lcg_cr3 (char *src_file, char *dest_file, char *guid, char *lfn, enum se_type defaulttype, enum se_type dst_setype,
		    int nobdii, char *vo, char *relative_path, int nbstreams, char *conf_file, int insecure,
		    int verbose, int timeout, char *spacetokendesc, char *GUIDOUT, char *errbuf, int errbufsz);
extern int lcg_cr4 (char *src_file, char *dest_file, char *guid, char *lfn, enum se_type defaulttype, enum se_type dst_setype,
		    int nobdii, char *vo, char *relative_path, int nbstreams, char *conf_file, int insecure, int verbose, int timeout,
            char *spacetokendesc, char *GUIDOUT, enum gfal_cksm_type cksmtype, char *errbuf, int errbufsz);

extern int lcg_rf (char *, char *, char *, char *, char *, int, int, char *GUIDOUT);
extern int lcg_rfxt (char *surl, char *guid, char *lfn, char *vo, char *conf_file,
		     int insecure, int verbose, int timeout, char *GUIDOUT, char *errbuf, int errbufsz);
extern int lcg_rf3 (char *surl, char *guid, char *lfn, enum se_type defaulttype, enum se_type setype,
		     int nobdii, char *vo, char *conf_file, int insecure, int verbose, int timeout,
		     char *GUIDOUT, char *errbuf, int errbufsz);

extern int lcg_stmd (char *spacetokendesc, char *endpoint, int *LEN, gfal_spacemd **LISTOUT,
		     int nobdii, int timeout, char *errbuf, int errbufsz);

extern int lcg_get_checksum (int LEN, char **LIST, enum se_type defaulttype, enum se_type setype, int nobdii,
		     int force, char *vo, enum gfal_cksm_type cksmtype, lcg_checksum **OUTPUT, char *errbuf, int errbufsz);
